-- 
-- Animal Helper 
-- 
-- @Author: StratoViking
-- @Date: 29.06.2020
-- @Version: 1.0.0.0
-- 

happyAnimals = {};


addModEventListener(happyAnimals);

animalChores = {
	["CHICKEN"] = function(husbandry)
		husbandry.modulesByName.food:changeFillLevels(husbandry.modulesByName.foodSpillage:getFoodSpillageLevel(), FillType.WHEAT)
		clearSpillage(husbandry)
		local freeCap = husbandry.modulesByName.food:getFreeCapacity(FillType.WHEAT)
		husbandry.modulesByName.food:setFillLevel(FillType.WHEAT, husbandry.modulesByName.food:getCapacity())
		local foodCost = freeCap * 1500 / 1000 * 1.025 -- 1500 per 1000 liters + 2.5% delivery fee (Store Deliveries Mod default)
		local laborCost = 15 -- fixed cost per pen.  May change to formula based on number of animals
		local cost = laborCost + foodCost
		return cost
	end,
	["SHEEP"] = function(husbandry)
		husbandry.modulesByName.water:setFillLevel(FillType.WATER, husbandry.modulesByName.water.fillCapacity)
		husbandry.modulesByName.food:changeFillLevels(husbandry.modulesByName.foodSpillage:getFoodSpillageLevel(), FillType.GRASS_WINDROW)
		clearSpillage(husbandry)
		local freeCap = husbandry.modulesByName.food:getFreeCapacity(FillType.GRASS_WINDROW)
		husbandry.modulesByName.food:setFillLevel(FillType.GRASS_WINDROW, husbandry.modulesByName.food:getCapacity())
		local foodCost = freeCap * 650 / 4000 * 1.025 -- 650 per 4000 liters + 2.5% delivery fee
		local laborCost = 30 -- sheep require a little more work
		local cost = laborCost + foodCost
		return cost
	end,
	["PIG"] = function(husbandry)
		husbandry.modulesByName.water:setFillLevel(FillType.WATER, husbandry.modulesByName.water.fillCapacity)
		local spilledFood = husbandry.modulesByName.foodSpillage:getFoodSpillageLevel()
		husbandry.modulesByName.food:changeFillLevels(spilledFood*0.5, FillType.MAIZE)
		husbandry.modulesByName.food:changeFillLevels(spilledFood*0.25, FillType.WHEAT)
		husbandry.modulesByName.food:changeFillLevels(spilledFood*0.2, FillType.SOYBEAN)
		husbandry.modulesByName.food:changeFillLevels(spilledFood*0.05, FillType.POTATO)
		clearSpillage(husbandry)
		local freeFoodCap = husbandry.modulesByName.food:getFreeCapacity(FillType.MAIZE) + husbandry.modulesByName.food:getFreeCapacity(FillType.WHEAT) + husbandry.modulesByName.food:getFreeCapacity(FillType.SOYBEAN) + husbandry.modulesByName.food:getFreeCapacity(FillType.POTATO)
		local capacity = husbandry.modulesByName.food:getCapacity()
		husbandry.modulesByName.food:setFillLevel(FillType.MAIZE, capacity)
		husbandry.modulesByName.food:setFillLevel(FillType.WHEAT, capacity)
		husbandry.modulesByName.food:setFillLevel(FillType.SOYBEAN, capacity)
		husbandry.modulesByName.food:setFillLevel(FillType.POTATO, capacity)
		local freeStrawCap = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
		husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, husbandry.modulesByName.straw.fillCapacity)
		local strawCost = freeStrawCap * 650 / 4000 * 1.025
		local foodCost = freeFoodCap * 1000 / 1000 * 1.025
		local laborCost = 75 -- pigs are needy
		local cost = laborCost + foodCost + strawCost
		return cost
	end,
	["HORSE"] = function(husbandry)
		husbandry.modulesByName.water:setFillLevel(FillType.WATER, husbandry.modulesByName.water.fillCapacity)
		local freeOatCap = husbandry.modulesByName.food:getFreeCapacity(FillType.OAT)
		local freeHayCap = husbandry.modulesByName.food:getFreeCapacity(FillType.DRYGRASS_WINDROW)
		local capacity = husbandry.modulesByName.food:getCapacity()
		husbandry.modulesByName.food:setFillLevel(FillType.OAT, capacity)
		husbandry.modulesByName.food:setFillLevel(FillType.DRYGRASS_WINDROW, capacity)
		local freeStrawCap = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
		husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, husbandry.modulesByName.straw.fillCapacity)
		local strawCost = freeStrawCap * 650 / 4000 * 1.025
		local foodCost = (freeOatCap * 1400 / 1000 + freeHayCap * 650 / 4000) * 1.025
		local laborCost = 45
		local cost = laborCost + foodCost + strawCost
		return cost
	end,
	["COW"] = function(husbandry)
		husbandry.modulesByName.water:setFillLevel(FillType.WATER, husbandry.modulesByName.water.fillCapacity)
		clearSpillage(husbandry)  -- don't bother with recovery of spillage.  possible future feature
		local freeFoodCap = husbandry.modulesByName.food:getFreeCapacity(FillType.FORAGE) 
		husbandry.modulesByName.food:setFillLevel(FillType.FORAGE, husbandry.modulesByName.food:getCapacity())
		local freeStrawCap = husbandry.modulesByName.straw:getFreeCapacity(FillType.STRAW)
		husbandry.modulesByName.straw:setFillLevel(FillType.STRAW, husbandry.modulesByName.straw.fillCapacity)
		local strawCost = freeStrawCap * 650 / 4000 * 1.025
		local foodCost = freeFoodCap * 300 / 1000 * 1.025 -- rough estimate for TMR cost using 75/25 mix of hay/silage and 700/L silage price
		local laborCost = 60
		local cost = laborCost + foodCost + strawCost
		return cost
	end
}

function clearSpillage(husbandry)
	for _, spillageArea in ipairs(husbandry.modulesByName.foodSpillage.spillageAreas) do
		local xs,_,zs = getWorldTranslation(spillageArea.start);
		local xw,_,zw = getWorldTranslation(spillageArea.width);
		local xh,_,zh = getWorldTranslation(spillageArea.height);
		DensityMapHeightUtil.clearArea(xs,zs, xw,zw, xh,zh);
		husbandry.modulesByName.foodSpillage.cleanlinessFactor = 1.0;
		husbandry:setModuleParameters("foodSpillage", 0, 0);
	end;
end;


function happyAnimals:loadMap()
	g_currentMission.environment:addHourChangeListener(happyAnimals);
--	happyAnimals.chickenFeed = g_storeManager:getItemByXMLFilename("data/objects/bigBagContainer/bigBagContainerChickenFood.xml");  -- may come back to data driven approach to prices
	self.hasRunToday = false;
end;

function happyAnimals:hourChanged()
	if not self.hasRunToday and g_currentMission.environment.currentHour == 8 then
		local totalCost = 0;
		for _,husbandry in pairs(g_currentMission.husbandries) do
			if (husbandry.ownerFarmId == 1) then
                local doChores = animalChores[husbandry.modulesByName.animals.animalType];
                if(doChores) then
                    totalCost = totalCost + doChores(husbandry);
                else
                    print(husbandry.modulesByName.animals.animalType .. " is not supported."); 	
                end;
            end;
		end;
		print("Total cost = " .. totalCost);
		g_currentMission:addMoney(-totalCost, 1, MoneyType.ANIMAL_UPKEEP, true, true);
		self.hasRunToday = true;
	elseif g_currentMission.environment.currentHour == 9 then
		self.hasRunToday = false;
	end;
end;

function happyAnimals:update(dt) end;
function happyAnimals:mouseEvent(posX, posY, isDown, isUp, button) end;
function happyAnimals:keyEvent(unicode, sym, modifier, isDown) end;
function happyAnimals:draw() end;
function happyAnimals:delete()end;
function happyAnimals:deleteMap() end;
